<!doctype html>
<html>
<head>
    <title>March 2009 Progress Report | The Tor Project</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="monetization" content="$ilp.uphold.com/pYfXb92JBQN4">
    <link rel="stylesheet" href="../static/css/style.css?h=5fc6c25a">
    <link rel="stylesheet" href="../static/fonts/fontawesome/css/all.min.css?h=9d272f6a">
    <link rel="stylesheet" href="../static/pygments.css">
    <link rel="icon" type="image/x-icon" href="../static/images/favicon/favicon.ico">
    <link rel="icon" type="image/png" href="../static/images/favicon/favicon.png">
    <meta property="og:title" content="March 2009 Progress Report | Tor Project">
    <meta property="og:description" content="New releases, new hires, new funding On March 9, we released Tor 0.2.1.13-alpha. It includes the...">
    <meta property="og:image" content="https://blog.torproject.org/static/images/lead.png">
    <meta property="og:url" content="https://blog.torproject.org/march-2009-progress-report/">
    <meta name="twitter:card" content="summary_large_image">
</head>
<body>
  <header>
    <nav>
      <a class="navbar-brand" href="../"><img alt="Tor Blog" src="../static/images/logo.png" /></a>
      <ul class="navbar-nav">
          <li><a href="https://www.torproject.org/about/history/">About</a></li>
          <li><a href="https://support.torproject.org/">Support</a></li>
          <li><a href="https://community.torproject.org/">Community</a></li>
          <li><a href="https://forum.torproject.org/">Forum</a></li>
          <li><a href="https://donate.torproject.org/">Donate</a></li></ul>
    </nav>
  </header>
  <section class="content">
    <main>
  <article class="blog-post">
      <h1 class="title">
        March 2009 Progress Report
      </h1>
    <p class="meta">by phobos | April 13, 2009</p>
    <picture>
      <source media="(min-width:415px)" srcset="../static/images/lead.webp" type="image/webp">
<source srcset="../static/images/lead_small.webp" type="image/webp">

      <img class="lead" src="../static/images/lead.png">
    </picture>
    <div class="body">
      <link rel="stylesheet" href="../static/css/legacy.css?h=21ddbb2d">
      <p><strong>New releases, new hires, new funding</strong></p>

<p>On March 9, we released Tor 0.2.1.13-alpha.  It includes the following fixes and enhancements:</p>

<p>o Major bugfixes:<br />
    - Correctly update the list of which countries we exclude as exits, when the GeoIP file is loaded or reloaded. Diagnosed by lark. Bugfix on 0.2.1.6-alpha.</p>

<p>  o Minor bugfixes (on 0.2.0.x and earlier):<br />
    - Automatically detect MacOSX versions earlier than 10.4.0, and<br />
      disable kqueue from inside Tor when running with these versions.<br />
      We previously did this from the startup script, but that was no<br />
      help to people who didn't use the startup script. Resolves bug 863.<br />
    - When we had picked an exit node for a connection, but marked it as<br />
      "optional", and it turned out we had no onion key for the exit,<br />
      stop wanting that exit and try again. This situation may not<br />
      be possible now, but will probably become feasible with proposal<br />
      158. Spotted by rovv. Fixes another case of bug 752.<br />
    - Clients no longer cache certificates for authorities they do not<br />
      recognize. Bugfix on 0.2.0.9-alpha.<br />
    - When we can't transmit a DNS request due to a network error, retry<br />
      it after a while, and eventually transmit a failing response to<br />
      the RESOLVED cell. Bugfix on 0.1.2.5-alpha.<br />
    - If the controller claimed responsibility for a stream, but that<br />
      stream never finished making its connection, it would live<br />
      forever in circuit_wait state. Now we close it after SocksTimeout<br />
      seconds. Bugfix on 0.1.2.7-alpha; reported by Mike Perry.<br />
    - Drop begin cells to a hidden service if they come from the middle<br />
      of a circuit. Patch from lark.<br />
    - When we erroneously receive two EXTEND cells for the same circuit<br />
      ID on the same connection, drop the second. Patch from lark.<br />
    - Fix a crash that occurs on exit nodes when a nameserver request<br />
      timed out. Bugfix on 0.1.2.1-alpha; our CLEAR debugging code had<br />
      been suppressing the bug since 0.1.2.10-alpha. Partial fix for<br />
      bug 929.<br />
    - Do not assume that a stack-allocated character array will be<br />
      64-bit aligned on platforms that demand that uint64_t access is<br />
      aligned. Possible fix for bug 604.<br />
    - Parse dates and IPv4 addresses in a locale- and libc-independent<br />
      manner, to avoid platform-dependent behavior on malformed input.<br />
    - Build correctly when configured to build outside the main source<br />
      path. Patch from Michael Gold.<br />
    - We were already rejecting relay begin cells with destination port<br />
      of 0. Now also reject extend cells with destination port or address<br />
      of 0. Suggested by lark.</p>

<p>  o Minor bugfixes (on 0.2.1.x):<br />
    - Don't re-extend introduction circuits if we ran out of RELAY_EARLY<br />
      cells. Bugfix on 0.2.1.3-alpha. Fixes more of bug 878.<br />
    - If we're an exit node, scrub the IP address to which we are exiting<br />
      in the logs. Bugfix on 0.2.1.8-alpha.</p>

<p>  o Minor features:<br />
    - On Linux, use the prctl call to re-enable core dumps when the user<br />
      is option is set.<br />
    - New controller event NEWCONSENSUS that lists the networkstatus<br />
      lines for every recommended relay. Now controllers like Torflow<br />
      can keep up-to-date on which relays they should be using.<br />
    - Update to the "February 26 2009" ip-to-country file.<br />
On March 10, we released Tor Browser Bundle 1.1.10.  It includes:<br />
Update Tor to 0.2.1.13-alpha<br />
Update Firefox to 3.0.7<br />
Update Pidgin to 2.5.5</p>

<p>On March 31, we released Tor Browser Bundle 1.1.11.  It includes:<br />
Update Firefox to 3.0.8<br />
Add Italian language bundles<br />
Update Torbutton to 1.2.1<br />
Update Vidalia to 0.1.12</p>

<p>On March 21, we released Torbutton 1.2.1, it includes:<br />
bugfix: bug 773: Fixed Noscript conflict issue.<br />
bugfix: bug 866: Fixed conflict with ZoTero<br />
bugfix: bug 908: Make UserAgentSwitcher's 'default' button restore Torbutton's spoofed user agent if Tor is enabled.<br />
bugfix: bug 909: Get Torbutton to "properly" react to users changing their Firefox cookie lifetime settings as opposed to using the Torbutton interface.<br />
bugfix: bug 834: Fix session saving and startup issues<br />
bugfix: bug 875: Removed docShell == null popup during toggle for some users<br />
bugfix: bug 910: fixed a locale spoofing issue in navigator.appVersion<br />
bugfix: bug 747: Attempt to fix 'fullscreen' resizing issues.<br />
bugfix: Stop-gap timezone spoofing fix for Linux and Mac for FF3. Requires a one-line patch to Firefox for Windows to work.<br />
bugfix: Clear SSL Session IDs on toggle. (See FF Bug 448747)<br />
misc: bug 931: Added a socks v4 vs v5 version choice to custom prefs.<br />
misc: bug 836: redesign startup preference window to make it more understandable<br />
misc: Torbutton now presents itself as Windows FF3.0.7.</p>

<p>On March 16, we released TorVM 0.0.1 as a testing release for user feedback and testing.  More about TorVM can be read at <a href="https://www.torproject.org/torvm/" rel="nofollow">https://www.torproject.org/torvm/</a></p>

<p>Vidalia 0.1.12  16-Mar-2009<br />
  o Fix a bug in the hidden service settings configuration class that<br />
    could lead to compile errors in Visual Studio and on IRIX.<br />
  o Fix a build error that occurred on IRIX when using the MIPSPro<br />
    compiler. Patch from Matthew Saunier.<br />
  o Remove two duplicated strings in the Spanish translation of Qt's<br />
    internal strings (qt_es.po). The duplicated strings caused build<br />
    errors when building with Qt 4.5. (Ticket #469)<br />
  o Remove the code that altered PublishServerDescriptor when becoming a<br />
    bridge, since Tor handles that itself now, and ensure that BridgeRelay<br />
    is reset when going from bridge to just-a-client mode.<br />
  o Remove an unnecessary #include from helpbrowser.cpp.<br />
  o Add an application icon based on Tor's logo to the vidalia.desktop<br />
    file.</p>

<p>Vidalia 0.2.0   19-Mar-2009<br />
  o Add support for changing UI languages without having to restart<br />
    Vidalia.<br />
  o Add preliminary support for using the KDE Marble widget for the<br />
    network map. It's currently a compile-time option and is disabled by<br />
    default.<br />
  o Add support for displaying Tor's plaintext port warnings. Also gives<br />
    the user the option to disable future warnings.<br />
  o Add an interface for displaying the geographic distribution of<br />
    clients who have recently used a bridge operator's relay.<br />
  o Add tooltips to tree items in the help browser's table of contents. Some<br />
    of the help topic labels are a bit long.<br />
  o Switch to a simpler About dialog and move the license information to a<br />
    separate HTML-formatted display.<br />
  o Switch to a simpler drag-and-drop installer in the OS X bundles.<br />
  o Switch to an MSI-based installer on Windows.<br />
  o Clear the list of default CA certificates used by QSslSocket before adding<br />
    the only one we care about. Suggested by coderman.<br />
  o Support building with Visual Studio again.<br />
  o Add a Debian package structure from dererk.<br />
  o Updated Albanian, Czech, Finnish, Polish, Portuguese, Romanian,<br />
    Swedish, Turkish and many other translations.</p>

<p>The Vidalia 0.2.0 release was also posted to the blog,<br />
<a href="https://blog.torproject.org/blog/technology-preview-marble-and-vidalia020" rel="nofollow">https://blog.torproject.org/blog/technology-preview-marble-and-vidalia0…</a></p>

<p><strong>Design, develop, and implement enhancements<br />
</strong><br />
The Torbutton 1.2.1 update fixes a number of bugs that protect users in censored countries.  Continued work on TorVM for easier and safer usage of Tor.  Continued development of the secure updater client for Tor. </p>

<p><strong>Architecture and technical design docs for Tor enhancements<br />
related to blocking-resistance.<br />
</strong><br />
Nick wrote up a blog entry describing our current plans for making<br />
libevent (and ultimately) Tor work well on Windows:<br />
<a href="https://blog.torproject.org/blog/some-notes-progress-iocp-and-libevent" rel="nofollow">https://blog.torproject.org/blog/some-notes-progress-iocp-and-libevent</a></p>

<p><strong>Grow the Tor network and user base. Outreach.<br />
</strong><br />
Andrew attended the LibrePlanet 2009 conference, <a href="http://www.fsf.org/associate/meetings/2009/" rel="nofollow">http://www.fsf.org/associate/meetings/2009/</a>.  Discussed Tor, free network services, and free software.</p>

<p>Karsten, Sebastian, and others helped organize and then attended Pet-Con 2009, <a href="http://www.pet-con.org/index.php/PET_Convention_2009.1" rel="nofollow">http://www.pet-con.org/index.php/PET_Convention_2009.1</a>.  </p>

<p>Nick wrote a blog post about the secure updater for Tor, codenamed Thandy, for Google's Open Source blog:  <a href="http://google-opensource.blogspot.com/2009/03/thandy-secure-update-for-tor.html" rel="nofollow">http://google-opensource.blogspot.com/2009/03/thandy-secure-update-for-…</a></p>

<p>Finished analyzing directory archives from February 2006 to February<br />
2009. This analysis gives a slightly better picture of the Tor network<br />
than the analysis of the 2008 data. The analysis shows that there is a<br />
clear trend reversal in the number of German relays in 2008, , but for other countries the number of relays has continued to increase.</p>

<p><a href="http://freehaven.net/~karsten/metrics/dirarch-2009-03-31.pdf" rel="nofollow">http://freehaven.net/~karsten/metrics/dirarch-2009-03-31.pdf</a></p>

<p>On March 17, Roger attended a hearing at the US Sentencing Commission,<br />
where Seth Schoen from EFF was testifying in opposition to a new "if<br />
you use a proxy when committing a crime, it's a sophisticated crime so<br />
you get more jail-time" clause they were considering. It turned out one<br />
of the commissioners is an avid Tor user, so they were sympathetic to<br />
his testimony. </p>

<p>On March 24-25, Roger and Andrew met with the Psiphon team in Toronto.<br />
We taught them about Tor's perspective on blocking-resistance, and about<br />
our bridges design. We also helped review their future design plans. We<br />
still have concerns that their closed design and implementation will<br />
ultimately mean they are less effective than they could be, but it's<br />
good to have alternate circumvention approaches available. </p>

<p>Tor (in combination with EFF) got accepted to Google Summer of Code<br />
2009. Google will be funding roughly 5 students to work on Tor-related<br />
development projects over this coming summer:<br />
<a href="https://blog.torproject.org/blog/eff-and-tor-google-summer-code-2009" rel="nofollow">https://blog.torproject.org/blog/eff-and-tor-google-summer-code-2009</a><br />
Our current thoughts are to focus on porting Polipo to Windows; improving<br />
usability and features for Torbutton; working harder to get WML support<br />
into Pootle, so people can translate our website with a browser; and<br />
further work on Thandy to make it scale better when 100000 users all<br />
try to upgrade in the same day.</p>

<p>Hal Roberts released his Berkman Center report on the "landscape of<br />
circumvention technologies" as of 2007, which recommends Tor and Psiphon:<br />
<a href="https://blog.torproject.org/blog/berkman-2007-circumvention-landscape-and-progress" rel="nofollow">https://blog.torproject.org/blog/berkman-2007-circumvention-landscape-a…</a> </p>

<p>Roger and Nick participated in the Codecon program committee, and helped<br />
to choose a variety of good development projects to showcase in April. Two<br />
of these turned out to be libevent (including the new Windows work),<br />
and Torflow:<br />
<a href="http://www.codecon.org/2009/program.html" rel="nofollow">http://www.codecon.org/2009/program.html</a> </p>

<p>Roger had lunch on March 4 with Micah Sherr, a PhD student at Penn who<br />
is working on a new path selection algorithm for Tor, that tries to<br />
minimize path latency rather than maximize bandwidth. Roger poked some<br />
holes in his design, and hopefully will help him over the next few months<br />
to fix them. You can read more about Micah's design in Section 4.3 of the<br />
"performance.pdf" document.</p>

<p>We worked with Global Voices to help them update their "guide to blogging<br />
anonymously":<br />
<a href="https://blog.torproject.org/blog/updated-guide-blogging-anonymously" rel="nofollow">https://blog.torproject.org/blog/updated-guide-blogging-anonymously</a><br />
In particular, we updated it to include recommendations for using Tor<br />
Browser Bundle, since TBB didn't exist when the guide was first written.</p>

<p><strong>Preconfigured privacy (circumvention) bundles for USB or LiveCD.<br />
</strong><br />
On March 10, we released Tor Browser Bundle 1.1.10.  It includes:<br />
Update Tor to 0.2.1.13-alpha<br />
Update Firefox to 3.0.7<br />
Update Pidgin to 2.5.5</p>

<p>On March 31, we released Tor Browser Bundle 1.1.11.  It includes:<br />
Update Firefox to 3.0.8<br />
Add Italian language bundles<br />
Update Torbutton to 1.2.1<br />
Update Vidalia to 0.1.12</p>

<p><strong>Bridge relay and bridge authority work.<br />
</strong><br />
From the changelog item from Vidalia 0.1.12:<br />
  o Remove the code that altered PublishServerDescriptor when becoming a<br />
    bridge, since Tor handles that itself now, and ensure that BridgeRelay<br />
    is reset when going from bridge to just-a-client mode.</p>

<p><strong>Scalability, load balancing, directory overhead, efficiency.<br />
</strong><br />
Roger and Steven wrote the Performance Roadmap as published at <a href="https://www.torproject.org/press/2009-03-12-performance-roadmap-press-release.html.en" rel="nofollow">https://www.torproject.org/press/2009-03-12-performance-roadmap-press-r…</a></p>

<p><strong>Footprints from Tor Browser Bundle.<br />
</strong><br />
March 17, updated research on traces left behind by the Tor Browser Bundle.  The current document can be found at <a href="https://svn.torproject.org/svn/torbrowser/trunk/docs/traces.txt" rel="nofollow">https://svn.torproject.org/svn/torbrowser/trunk/docs/traces.txt</a>.</p>

<p><strong>Translations</strong><br />
21 Polish website translations<br />
20 French website translations<br />
53 Italian website translations<br />
25 German website translations<br />
5 Chinese website translations<br />
5 Updates from the translation portal for torbutton, in French, Italian, and Bokmål (Norwegian)</p>

    </div>
  <div class="categories">
    <ul><li>
        <a href="../category/releases">
          releases
        </a>
      </li><li>
        <a href="../category/reports">
          reports
        </a>
      </li></ul>
  </div>
  <div class="comments">
      <h2>Comments</h2>
      <p>Please note that the comment area below has been archived.</p>
      <a id="comment-1509"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-1509" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Samuel (not verified)</span> said:</p>
      <p class="date-time">June 09, 2009</p>
    </div>
    <a href="#comment-1509">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-1509" class="permalink" rel="bookmark">I&#039;m glad to see so many</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>I'm glad to see so many European languages. I'm sick of all the software that has only international languages.<br />
___________<br />
Samuel Stanislas, part of the <a href="http://www.activ-traduceri.ro" rel="nofollow">Traduceri</a> team.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-1774"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-1774" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Sandra (not verified)</span> said:</p>
      <p class="date-time">July 09, 2009</p>
    </div>
    <a href="#comment-1774">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-1774" class="permalink" rel="bookmark">Besides the obvious</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Besides the obvious satisfaction of building something up, do you guys get payed enough for so much work?<br />
_______________<br />
<a href="http://www.Houstonlandscaper.org" rel="nofollow">Houston landscaper</a></p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-2643"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-2643" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Eddie Petosa (not verified)</span> said:</p>
      <p class="date-time">September 26, 2009</p>
    </div>
    <a href="#comment-2643">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-2643" class="permalink" rel="bookmark">I see everyone has a</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>I see everyone has a question though they get no answer. I'll try my luck too. I'm curious if you have a team of programmers or if anyone can contribute with their own code. I know mixing up programming styles isn't a good idea but Linux has offered that for its users and it seems to be successful enough.<br />
______________<br />
<a href="http://www.donhost.co.uk/dedicated-servers/linux-dedicated-hosting/" rel="nofollow">Linux dedicated server</a></p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-3343"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-3343" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span content="best online casino gambling site">best online ca… (not verified)</span> said:</p>
      <p class="date-time">November 27, 2009</p>
    </div>
    <a href="#comment-3343">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-3343" class="permalink" rel="bookmark">Visual Basic developers had</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Visual Basic developers had to implement a Custom Event or another workaround when their types needed to expose an Event and they had to be Serializable.  C# had this capability, now Visual Basic does too!..Visual Basic developers can now decorate the Event with the Non Serialized attribute. ..<br />
<a href="http://www.888casino.ws/" rel="nofollow">http://www.888casino.ws/</a></p>
</div>
  </div>
</article>
<!-- Comment END -->
  </div>
  </article>

</main>
    <aside class="sidebar">
<!-- ##SIDEBAR## -->
</aside>
  </section>
  <footer><div class="row download">
    <div class="col circles"></div>
    <div class="col link">
        <h3>Download Tor Browser</h3>
        <p>Download Tor Browser to experience real private browsing without tracking, surveillance, or censorship.</p>
        <a class="btn" href="https://www.torproject.org/download/">Download Tor Browser <i class="fas fa-arrow-down-png-purple"></i></a>
    </div>
</div>
<div class="row social">
    <div class="col newsletter">
        <h3>Subscribe to our Newsletter</h3>
        <p>Get monthly updates and opportunities from the Tor Project:</p>
        <p class="w"><a class="btn btn-dark" role="button" href="https://newsletter.torproject.org/">Sign up</a></p>
    </div>
    <div class="col links">
        <div class="row">
            <h4><a target="_blank" href="https://www.facebook.com/TorProject/"><i class="fab fa-facebook"></i></a></h4>
            <h4><a target="_blank" href="https://mastodon.social/@torproject" rel="me"><i class="fab fa-mastodon"></i></a></h4>
            <h4><a target="_blank" href="https://twitter.com/torproject"><i class="fab fa-twitter"></i></a></h4>
        </div>
        <div class="row">
            <h4><a target="_blank" href="https://www.instagram.com/torproject"><i class="fab fa-instagram"></i></a></h4>
            <h4><a target="_blank" href="https://www.linkedin.com/company/tor-project"><i class="fab fa-linkedin"></i></a></h4>
            <h4><a target="_blank" href="https://github.com/torproject"><i class="fab fa-github"></i></a></h4>
        </div>
        <div class="row">
            <h4><a target="_blank" href="https://t.me/torproject"><i class="fab fa-telegram"></i></a></h4>
        </div>
    </div>
</div>
<div class="row notice">
    <p>Trademark, copyright notices, and rules for use by third parties can be found in our <a href="https://www.torproject.org/about/trademark/">FAQ</a>.</p>
</div></footer>
</body>
</html>
